#include<iostream>
/* 
Corso di Programmazione II - Prof. Dario Catalano.
Soluzione della prova d'esame del 08/10/2014. 
Il compito è svolto senza fare uso di templates
*/

using namespace std;

class MultiBST	{
public: 
	virtual MultiBST* ins(int x) =0;
	virtual int multiplicity(int x) =0;
	virtual void inorder()=0;
};

class Nodo	{
private:
	Nodo* padre, *left, *right; 
	int chiave; 
	int molt; 
public:
	Nodo(int val) {	//Costruttore
		chiave=val; 
		padre=left=right=NULL; 
		molt=1; }
	int getChiave() {return chiave;}	
	int getMultiplicity() {return molt;} 
	void setMultiplicity(int p) {molt=p;} 
	void setPadre(Nodo* p) {padre=p;}
	Nodo* getPadre() {return padre;}
	Nodo* getDestro() {return right;}
	void setDestro(Nodo* p) {right=p;}
	Nodo* getSinistro() {return left;}
	void setSinistro(Nodo* p) {left=p;}
	void setChiave(int p) {chiave=p;}
};

class MyMultiBST : public MultiBST {
private:
	Nodo* radice; 
public:
	MyMultiBST () {radice=NULL;}
	Nodo* getRoot() {return radice;}
	void setRoot(Nodo* p) {radice=p;}
	MultiBST* ins(int x); 
	void visita_inorder(Nodo* p);
	int multiplicity(int x);
	Nodo* search (int p); // restituisce il nodo 
						  // dove si trova p
	void inorder(); 
	MultiBST* del(int x);
	void Trapianta(Nodo* u, Nodo*); 
	Nodo* Minimo(Nodo* p);
	int rank(int x); 
	Nodo* successore(Nodo* x);
};

Nodo* MyMultiBST:: search (int p) {
	Nodo *temp=radice; 
	
	while ((temp!=NULL) && (temp->getChiave()!=p)) 
		if  (temp->getChiave() > p) temp=temp->getSinistro(); 
		else temp=temp->getDestro();
	return temp; 
}

MultiBST* MyMultiBST :: ins(int key)	
{	 
	Nodo *x=radice, *y=NULL;
	
	Nodo *temp=search(key); 
	if (temp) {temp->setMultiplicity((temp->getMultiplicity())+1);}
	else {
		while (x!=NULL) {
			y=x; 
			if (key < x->getChiave()) x=x->getSinistro(); 
			else x=x->getDestro(); 
			}
		Nodo* nuovo=new Nodo(key);
		nuovo->setPadre(y); 
		if (y==NULL) 
			radice=nuovo; 
		else if (key < (y->getChiave())) y->setSinistro(nuovo); 
		else y->setDestro(nuovo);	
		return this; 
		}
}


void MyMultiBST :: inorder () 
{
 	cout << endl; 
	visita_inorder(radice);
	cout << endl; 		
}

void MyMultiBST :: visita_inorder (Nodo* p) {
	if (p!=NULL) {
 		visita_inorder(p->getSinistro());
 		for(int i=0; i<p->getMultiplicity(); i++)
 			cout << (p->getChiave()) << "\t"; 
 		visita_inorder(p->getDestro()); 
 	}
}

int MyMultiBST:: multiplicity (int x) 
{
	Nodo* temp=search(x); 
	
	if (temp) return temp->getMultiplicity(); 
	else return 0; 
} 


void MyMultiBST:: Trapianta(Nodo* u, Nodo* v)	{
	if (u->getPadre()==NULL) radice=v; 			
	else if (u==u->getPadre()->getSinistro()) 			
       u->getPadre()->setSinistro(v); 
	else  
		u->getPadre()->setDestro(v);
	if (v!=NULL) 						
 		v->setPadre(u->getPadre()); 
}

Nodo* MyMultiBST::Minimo(Nodo* x)	{
	Nodo* min=x; 
	
	while(min->getSinistro() != NULL) min=min->getSinistro(); 
	return min; 
}

MultiBST* MyMultiBST :: del (int p) {
	Nodo* y; 
		
	Nodo* z=search(p);
	if (z) {
		if (z->getMultiplicity()>1) {
			z->setMultiplicity((z->getMultiplicity())-1); 
			}
		else {
			if (z->getSinistro()==NULL) Trapianta(z, z->getDestro()); 
			else if (z->getDestro()==NULL)
				Trapianta(z, z->getSinistro());
			else {
				y=Minimo(z->getDestro()); 
				if (y->getPadre()!=z)	{
					Trapianta(y,y->getDestro()); 
					y->setDestro(z->getDestro()); 
					y->getDestro()->setPadre(y);
				}
				Trapianta(z,y); 
				y->setSinistro(z->getSinistro()); 
				y->getSinistro()->setPadre(y); 	
				}
			delete z;
			}
	}
	else cout << "Elemento non presente nell'albero \n"; 
	return this; 
}

int MyMultiBST :: rank (int p) {
	Nodo* x=search(p);
	
	if (!x) return 0; 
	else {
		int rango=1; 
		x=Minimo(radice);
		while (x->getChiave()<p) {
			rango=rango+(x->getMultiplicity());
			x=successore(x); }
		return rango;  
	} 
}


Nodo* MyMultiBST:: successore(Nodo* x)	{
	if (x==NULL) return NULL; 
	if (x->getDestro()!=NULL) return Minimo(x->getDestro()); 
	Nodo* y=x->getPadre(); 
	while ((y!=NULL) && (y->getChiave() < x->getChiave()) )
		y=y->getPadre();
	return y; 
}


int main()
{	
	MyMultiBST Tree; 
	//int vettore[]={1,2,3,4,5,6,7,8,9,10,11,12,13};
	int input[]={10,7,7,23,30,4,1,5,9,5,1,7,1,9};

	for(int i=0; i<14; i++)
		Tree.ins(input[i]);	
	Tree.inorder(); 
	cout << "Molteplicità di 3: " << Tree.multiplicity(3);
	cout << "\n Molteplicità di 7: " << Tree.multiplicity(7);
	cout << "\n Molteplicità di 10: " << Tree.multiplicity(10) << endl << endl;
	Tree.del(7);
	Tree.del(4);
	Tree.del(23);
	Tree.del(7);
	Tree.del(7);
	Tree.inorder(); 
	cout << "Molteplicità di 3: " << Tree.multiplicity(3);
	cout << "\n Molteplicità di 7: " << Tree.multiplicity(7);
	cout << "\n Molteplicità di 23: " << Tree.multiplicity(23) << endl << endl;
	/*
	Nodo* elemento=Tree.searchInt(21);
	if (elemento!=NULL) 
		Tree.del(elemento->getChiave()); 
	Tree.postorderPrint(); 	
	*/
	cout << "Rango di 5: " << Tree.rank(5);
	cout << "\n Rango di 9: " << Tree.rank(9);
	cout << "\n Rango di 30: " << Tree.rank(30) << endl << endl;
	return 0;	
}